function changeress(msg, comchap) {
	$.ajax({//Exécution d'une requete AJAX (requete http sans avoir à recharger la page)
		type: "POST",
		url: "traitechapitre.php",
		data: { num_chapitre: msg, comchap: comchap }, //Les données à envoyer dans la requête (Je ne pense pas qu'il n'est pas necéssaire de faire le escape)
		success: afficherress,	//La fonction a apeller en cas de succès de la requete
		error: function(){alert("Erreur !");},	//La fonction en cas d'erreur
		dataType: "xml",	//Le type de données retournée (pour faciliter le traitement après)
	});
}

function afficherress(xml) {
    var appendHtml = ""; //Le code HTML qui sera ajouté

    $("#ress").empty();//On vide le cadre

    //C'est parti...
    $(xml).find('ressource').each(function(){
        //On récupère toutes les valeurs des noeuds
        var couleur_ressource = $(this).find('couleur_ressource').text();
        var couleur_soustitre = $(this).find('couleur_soustitre').text();
        var icone = $(this).find('icone').text();
        var nom = $(this).find('nom').text();
		var sous_titre = $(this).find('sous_titre').text();
        var lien = $(this).find('lien').text();
        var droit = $(this).find('droit').text();
        var date = $(this).find('date').text();
        var auteur = $(this).find('auteur').text();
        var type1 = $(this).find('type1').text();

		//La ligne magique pour gérer les caractères html dans le nom (<, >, &, ...)
		nom = $('<div />').text(nom).html();
		sous_titre = $('<div />').text(sous_titre).html();
		// gestion du retour à la ligne
		nom = nom.replace("&lt;br /&gt;","<br />");
		nom = nom.replace("&lt;br&gt;","<br />");
		sous_titre = sous_titre.replace("&lt;br /&gt;","<br />");
		sous_titre = sous_titre.replace("&lt;br&gt;","<br />");
		
        //Les icônes varies en fonction du type et droit
        switch (type1){
            case "exe":
                var image1 = "images/exe.png";
                break;
            case "cartable":
                var image1 = "images/fichier.png";
                break;
            case "web":
                var image1 = "images/web.png";
                break;
            default:
                var image1 = "images/fichier.png";  // image par défaut
                break;
        }
        switch (droit){
            case "prof":
                var image2 = "images/prof.png";
                var image2title = "La ressource ["+nom+"] est réservée aux professeurs";
                break;
            case "eleve":
                var image2 = "images/eleve.png";
                var image2title = "La ressource ["+nom+"] est réservée aux élèves inscrits";
                break;
            case "public":
                var image2 = "images/pixtrsp.gif";
                var image2title = "";
                break;
            default:
                var image2 = "images/pixtrsp.gif";  // image par défaut
                var image2title = "";
                break;
        }

        var tr = '<a target="_blank" href="'+lien+'">'+
                '<div class="cadrer">' +
				'<table width="100%" border="0" cellspacing="0" cellpadding="0" valign="middle" height="52"><tr><td width="40"><img id="icone" src="../../partage/icones/'+icone+'" border="0" height="40"></td><td width="10"></td><td><font color="'+couleur_ressource+'" size="2" face="Arial, Helvetica, sans-serif"><a style="font-weight: bold; text-decoration:none;">'+nom+'</a><br /><font color="'+couleur_soustitre+'" size="2" face="Times New Roman, Arial, Helvetica, sans-serif"><em>'+sous_titre+'</em></td><td align="right" width="40"><img id="droite2" src="'+image2+'" border="0" height="30" title="'+image2title+'"></td><td align="right" width="40"><img id="droite2" src="'+image1+'" border="0" height="30"></td></tr></table>'+
				'</div>'+
				'</a>';
        appendHtml += tr;
		
    });

    //C'est fini !
    $("#ress").append(appendHtml);

    //On récupère le numéro de chapitre, met à gauche tous les chapitres, puis à droite le chapitre en cours
    var comchap = $(xml).find('comchap').text();
    $('#chap li').attr('id','lis1');
    $('#chap li:eq('+(comchap - 1)+')').attr('id','lis');
}