<?php
/*******************************************************************************************
*   Script du module GestFiles réalisé par Gquick pour le projet JBC Explorer v7+
*   Site web du projet : http://jcjcjcjc.free.fr/
*   Forum du projet : http://www.freescript.be/viewforum.php?forum=10
*   Forum du module : http://www.freescript.be/viewtopic.php?topic=???&forum=16
*
*   Le script permet la gestion des fichiers / dossiers directement dans l'explorer
*   Uniquement en mode authentifié et en visualisation par liste
*
*  Ce Module est basé sur les travaux de JPR
*
*  MISE EN GARDE : 
*  Pour fonctionner ce module nécessite un "Hack" (ie une modification) 
*  du fichier .dirsys/liste.php (voir notice.txt)
*
*  Evolutions :
*  v 1.00	06/03/2005	Gquick		Création sous forme de module
*								avec reprise des travaux de JPR
*  v 1.01	07/03/2005	Gquick		Corrections Bug
*		- Correction Bug de la gestion <input type=image> qui ne passe comme un submit sous IE
*		- Ajout vérification stricte des noms des répertoires créer
*  v 1.02	15/03/2005	Gquick		Ajout fonction de renommage de fichier
*								simplification de la mise en forme
*  v 1.03	18/03/2005	Gquick		Correction Bug "selectionner tout"
*  v 1.04	19/03/2005	Gquick		Correction Bugs de mise en forme
*								et sur renommage des dossiers
*								ajout robustesse sur le hacking
*  v 1.05	20/05/2005	Gquick		Compatibilité avec Explorer 7.05
*  v 1.06	20/05/2005 	Polysosycs & Gquick
*								Ajout de la compression au format zip
*								et de la décomptession au format zip, tar.gz, tgz, tar
*								utilise la librairie pclzip
*******************************************************************************************/
	include_once('../config.inc.php');
	@include('./gestfiles/gestfiles.conf.php');
	(@include_once('./gestfiles/gestfiles.func.php')) or die('ERREUR - Module incomplet => il manque gestfiles.fonc.php');
	(@include_once('./gestfiles/hackfiles.func.php')) or die('ERREUR - Module incomplet => il manque hackfiles.fonc.php');
?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
<title><?php echo $ModuleTitle ?></title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<link href="../styles/<?php echo $CONFIG['CSS'] ?>" rel="stylesheet" type="text/css">
</head>
<body>
<?php
	// gestion des actions (POST)
	if ($gf_isauth) {
		if (isset($_POST['hack_action'])) {
			switch ($_POST['hack_action']) {
			case 'Supprimer':
				gf_hack_gestfiles_remove();
				break;
			case 'Ajouter':
				gf_hack_gestfiles_add();
				break;
			}
			unset($_POST['hack_action']);
		}
		if (isset($_POST['MAJ_Config'])) {
			// Protection de la saisie
			$zip_format='.zip';
			switch ($_POST['zip_format']) {
				case '.zip':
				case '.tgz':
				case '.tar.gz':
				case '.tar':
					$zip_format=$_POST['zip_format'];
			}
			$conf="<?php\n";
			$conf.="\t\$GESTFILES_CONF['ZIP_PATH']=".(($_POST['zip_path']=='true')? 'true':'false').";\n";
			$conf.="\t\$GESTFILES_CONF['ZIP_FORMAT']='".$zip_format."';\n";
			$conf.="?>\n";
			$fp=@fopen('./gestfiles/gestfiles.conf.php','wt');
			if ($fp) {
				fwrite($fp,$conf);
				echo '<b>Mise à jour effectuée avec succès</b><br><br>';
			} else echo '<b>ERREUR de Mise à jour</b><br><br>';
            fclose($fp);
			@include('./gestfiles/gestfiles.conf.php');
		}
	}
?>
	<table width="100%" border="0" cellpadding="1" cellspacing="0">
	<tr class="bande" >
	<td class="miniatureliste" >[<b> <?php echo $ModuleTitle ?> </b>] </td>
	</tr>
	</table>
	<br>
 <p><table  border="0" align="center" width="60%" class="tn">
  <tr> 
    <td><p align="center"><font color="blue" size="2" face="Arial, Helvetica, sans-serif">
    Ce module vous permet de gérer les fichiers/dossiers directement dans l'explorer.<br>
    <br>Ouvrez le répertoire à gérer en affichage &laquo;<b>liste</b>&raquo; ou &laquo;<b>miniature</b>&raquo;.<br>
    </font></p></td>
  </tr>
</table></p>
<?php
	if (!$gf_isauth) die('<h1 align=center><font color=red>Avant, il faut cliquer sur Connexion</font></h1></body></html>');
	$hack_code_ok=gf_hack_gestfiles_test()
?>
<p><hr><table align='center' cellspacing=20>
	<tr><td colspan=3><font size=3 color='green'><b>Fonctions <?php if (!$hack_code_ok) echo '<b>NON </b>'?>accessibles (mode authentifié) :</b></font></td></tr>
	<tr><td><img src="<?php echo gf_getIcon('../','delete') ?>" alt="Effacer" title="Effacer" align="middle"></td>
		<td>Effacer</td>
		<td>Effacer les fichiers ou dossiers sélectionnés.<br>
			Même les répertoires non vides peuvent être effacés.</td></tr>
	<tr><td><img src="<?php echo gf_getIcon('../','copy') ?>" alt="Copier" title="Copier" align="middle"></td>
		<td>Copier</td>
		<td>Copier les fichiers sélectionnées (ne fonctionne pas avec les dossiers).<br>
			La copie sera réalisée dans le dossier courant lors de l'action &laquo;Coller&raquo;.</td></tr>
	<tr><td><img src="<?php echo gf_getIcon('../','cut') ?>" alt="Couper" title="Couper" align="middle"></td>
		<td>Couper</td>
		<td>Couper (prépare un déplacement) les fichiers sélectionnés (ne fonctionne pas avec les dossiers).<br>
			Le deplacement sera réalisé dans le dossier courant lors de l'action &laquo;Coller&raquo;.</td></tr>
	<tr><td><img src="<?php echo gf_getIcon('../','paste') ?>" alt="Coller" title="Coller" align="middle"></td>
		<td>Coller</td>
		<td>Coller les fichiers préalablement mémorisés lors d'une action &laquo;Copier&raquo; ou &laquo;Couper&raquo;.<br>
			Pour éviter un écrasement, les fichiers portants le m&ecirc;me nom seront renommés.</td></tr>
	<tr><td><img src="<?php echo gf_getIcon('../','newfolder') ?>" alt="Créer dossier" title="Créer dossier" align="middle"></td>
		<td>Créer dossier</td>
		<td>Création d'un nouveau dossier à l'emplacement courant (Max. 20 caractères).<br>
			ATTENTION - Donne les droits maximum (0777) &agrave; ce nouveau dossier.</td></tr>
	<tr><td><img src="<?php echo gf_getIcon('../','ren') ?>" alt="Renommer" title="Renommer" align="middle"></td>
		<td>Renommer</td>
		<td>Renomme le ou les fichiers / dossiers sélectionnées par celui saisie dans la zone de texte.<br>
			Si plusieurs fichiers sont sélectionnés, leur nouveau nom sera postfixé par un incrément.</td></tr>
	<tr><td><img src="<?php echo gf_getIcon('../','zip') ?>" alt="Compresser/Décompresser" title="Compresser/Décompresser" align="middle"></td>
		<td>Compresser<br>Décompresser</td>
		<td>Compresse le ou les fichiers / dossiers sélectionnés au format zip.<br>
			Décompresse le ou les fichiers aux formats reconnues (zip, tar, gz).</td></tr>
</table></p>
<hr>
<form name='conf_gestfiles' method='POST'>
<table align='center' cellspacing=10>
	<tr><td colspan=3><font size=2><b>Configuration :</b></font></td></tr>
	<tr><td align='right'>Utilisation des chemins relatifs pour compresser/décompresser :</td>
		<td><input type="radio" name="zip_path" value="true"  <?php if ($GESTFILES_CONF['ZIP_PATH']) echo "checked"; ?> > OUI</td>
		<td><input type="radio" name="zip_path" value="false" <?php if (!$GESTFILES_CONF['ZIP_PATH']) echo "checked"; ?> > NON</td>
		</tr>
	<tr><td align='right'>Format pour la compression :</td>
		<td colspan=2><select name="zip_format" size="1">
		<option value=".zip" <?php if ('.zip'==$GESTFILES_CONF['ZIP_FORMAT']) echo "selected"; ?> >.zip</option>
		<option value=".tgz" <?php if ('.tgz'==$GESTFILES_CONF['ZIP_FORMAT']) echo "selected"; ?> >.tgz</option>
		<option value=".tar.gz" <?php if ('.tar.gz'==$GESTFILES_CONF['ZIP_FORMAT']) echo "selected"; ?> >.tar.gz</option>
		<option value=".tar" <?php if ('.tar'==$GESTFILES_CONF['ZIP_FORMAT']) echo "selected"; ?> >.tar</option>
		</selected></td></tr>
	<tr><td colspan=3 align="center"><input type="submit" name="MAJ_Config" value="Mettre à jour"></td></tr>
</table>
</form>
<hr>
<?php if (!$hack_code_ok) echo "<h2>"; ?>
<p align='center'>Le &laquo;Hack code&raquo; nécessaire au fonctionnement du module est :
<font color=<?php if ($hack_code_ok) echo "green>PR&Eacute;SENT"; else echo "red>ABSENT"; ?></font></p>
<form name='hack_gestfiles' method='POST'>
<?php
	if ($hack_code_ok) {
		echo "<input type='hidden' name='hack_action' value='Supprimer'>";
		echo "<p align='center'>Vous pouvez supprimer ce &laquo;Hack code&raquo;
			  mais cela va <a href='#' onclick='document.hack_gestfiles.submit()'><font color='red'>rendre le module innopérationnel !</font></a></p>";
	} else {
		echo "<input type='hidden' name='hack_action' value='Ajouter'>";
		echo "<h3 align='center'>Vous pouvez ajouter ce &laquo;Hack code&raquo;
			  pour <a href='#' onclick='document.hack_gestfiles.submit()'><font color='green'>rendre le module opérationnel !</font></a></h3>";
	}
?>
</form>
<?php if (!$hack_code_ok) echo "</h2>"; ?>
<hr><address><p align='center'>Module &laquo;<? echo $ModuleTitle ?>&raquo; - V <? echo $gf_version ?> - [Gquick]</p></address>
</body>
</html>

